using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using KendoMVCWrappers.Models;
using Kendo.Mvc.UI;
using Kendo.Mvc.Extensions;

namespace KendoMVCWrappers.Controllers
{
    public class HomeController : Controller
    {
        public static List<Person> persons = new List<Person>();
        public static List<dynamic> roles;

        static HomeController()
        {
            persons.Add(new Person { PersonID = 1, Name = "John", BirthDate = new DateTime(1968, 6, 26) ,RoleID = 1 });
            persons.Add(new Person { PersonID = 2, Name = "Sara", BirthDate = new DateTime(1974, 9, 13) , RoleID = 3});

            roles = new List<dynamic>{
                new {RoleID=1,RoleName="Role 1"},
                new {RoleID=2,RoleName="Role 2"},
                new {RoleID=3,RoleName="Role 3"},
                new {RoleID=4,RoleName="Role 4"},
            };
        }

        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to kick-start your ASP.NET MVC application.";
            ViewData["Roles"] = roles;
            return View();
        }

        public ActionResult GetPersons([DataSourceRequest] DataSourceRequest dsRequest)
        {
            var result = persons.ToDataSourceResult(dsRequest);
            return Json(result);
        }

        public ActionResult GetRoles(string name)
        {
            if (name == "John") {
                return Json(roles.Take(2));
            }
            return Json(roles.Skip(2));
        }

        public ActionResult UpdatePerson([DataSourceRequest] DataSourceRequest dsRequest,Person person)
        {
            if (person!=null && ModelState.IsValid)
            {
                var toUpdate = persons.FirstOrDefault(p => p.PersonID == person.PersonID);
                TryUpdateModel(toUpdate);
            }
            
            
            return Json(ModelState.ToDataSourceResult());
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your quintessential app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your quintessential contact page.";

            return View();
        }
    }
}
